local dndBanner = "<SBW> "
local dndString = dndBanner .. "I'm busy fighting %s. You'll be notified when combat ends."
local combatEndedString = dndBanner .. "Combat ended."

local frame = CreateFrame("Frame")
local addonName = ...
local pname = UnitName("player")
local whisperers = {}
local bosses = {}

function frame:PLAYER_REGEN_ENABLED()
	for player in pairs(whisperers) do
		SendChatMessage(combatEndedString, "WHISPER", nil, player)
	end
	wipe(whisperers)
	wipe(bosses)
end

function frame:ADDON_LOADED(msg)
	if msg ~= addonName then return end
	self:UnregisterEvent("ADDON_LOADED")
	if not SBW_DisableChatFilter then
		local bannerTest = "^" .. dndBanner
		ChatFrame_AddMessageEventFilter("CHAT_MSG_WHISPER_INFORM", function(self, event, msg)
			if msg:find(bannerTest) then return true end
		end)
	end
end

function frame:CHAT_MSG_WHISPER(msg, sender, _, _, _, gm)
	if not UnitExists("boss1") then return end
	if type(sender) ~= "string" or sender == pname or
	  (UnitExists("target") and UnitName("target") == sender) or UnitInRaid(sender) or
	  (type(gm) == "string" and gm == "GM") then return end

	if #bosses == 0 then
		for i = 1, MAX_BOSS_FRAMES do
			if UnitExists("boss" .. i) then
				bosses[i] = UnitName("boss" .. i)
			end
		end
	end

	if not whisperers[sender] or msg == "status" then
		-- Let him know we are fighting a boss
		whisperers[sender] = true
		SendChatMessage(dndString:format(table.concat(bosses, ", ")), "WHISPER", nil, sender)
	end
end

frame:SetScript("OnEvent", function(self, event, msg, ...) self[event](self, msg, ...) end)
frame:RegisterEvent("CHAT_MSG_WHISPER")
frame:RegisterEvent("PLAYER_REGEN_ENABLED")
frame:RegisterEvent("ADDON_LOADED")
